package tournament;

import java.util.List;

public abstract class Game {
   private static int counter = 0;
   private final int id;
   //null nicht notwendig
   private String winner = null;


   protected Game() {
       this.id = counter++;
   }

   public int getId(){
       return this.id;
   }

   public String getWinner(){
       return this.winner;
   }

   public void setWinner(String winner) {
       String player1 = getPlayer1();
       System.out.println("Player 1: " + player1);
       String player2 = getPlayer2();
       System.out.println("Player 2: " + player2);
        this.winner = this.winner == null && player1 != null && player2 != null && (winner == player1 || winner == player2) ? this.winner = winner : this.winner;
   }

   public abstract String getPlayer1();

   public abstract String getPlayer2();

   public abstract List<String> getAllPlayers();

    public abstract List<String> getRemaningPlayers();
    
    public abstract List<Game> getAllGames();

   public String toString(){
      return "Game: " + getId() + " Player: "+ getPlayer1()+ " vs Player: " + getPlayer2() + "Winner is: "+ getWinner();
   }


}
